#include <htc.h>
#define _XTAL_FREQ 20000000l

__CONFIG(FOSC_HS & LVP_OFF & PWRTE_ON & BOREN_OFF & WDTE_OFF);

void initI2c()
{
	TRISC3 = TRISC4 = 1;
	SMP = 1;
	CKE = 0;
	SSPM3 = 1;
	SSPM2 = 0;
	SSPM1 = 0;
	SSPM0 = 0;
	
	SSPADD = 49;
}

int main()
{

	TRISB = 0XFF;
	TRISD = 0;
	initI2c();
	SSPEN = 1;
	__delay_ms(1);
	while(1)
	{
		SEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		do{
			SSPBUF = 0x00;
			if(WCOL)	WCOL = 0;
			while(!SSPIF);	SSPIF = 0;
		}while(ACKSTAT);
		
		SSPBUF = PORTB;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		
		PEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		
		SEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		do{
			SSPBUF = 0x00;
			if(WCOL)	WCOL = 0;
			while(!SSPIF);	SSPIF = 0;
		}while(ACKSTAT);
		
		RSEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		do{
			SSPBUF = 0x01;
			if(WCOL)	WCOL = 0;
			while(!SSPIF);	SSPIF = 0;
		}while(ACKSTAT);
		
		RCEN = 1;
		while(!BF);
		PORTD = SSPBUF;
		while(!SSPIF);	SSPIF = 0;
		ACKDT = 1;
		ACKEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
		
		PEN = 1;
		if(WCOL)	WCOL = 0;
		while(!SSPIF);	SSPIF = 0;
	}
	return 0;
}